<template>
  <div class="hexagon-container">
    <div class="hexagon" v-for="(container, key) in containers" :key="key">
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      containers: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10],
    }
  }
}
</script>

<style>
.hexagon-container {
  --hex-width: 80px;
  --hex-between: 8px;
  --sqrt-3: 1.732050807568877;
  --hex-height: calc(var(--hex-width) / var(--sqrt-3));
  --hex-margin: calc(var(--hex-width) / 2);
  --hex-border: calc(var(--hex-margin) / var(--sqrt-3));
  --hex-transition: all 0.2s ease;
  --color-hex-default: #eee;
  --color-hex-hover: #409eff;
  --color-hex-hover-color: #fff;
  --color-background: rgb(35, 47, 62);
  --color-header-fontend: rgb(4, 101, 229);
  --color-global-bg: rgb(245, 245, 245);
  --color-font-color: #606266;

  position: relative;
  height: 100%;
  width: 100%;
  grid-column-start: 1;
  grid-column-end: 2;
  grid-row-start: 2;
  grid-row-end: 3;
  display: grid;
  grid-template-columns: repeat(6, var(--hex-width));
  grid-auto-rows: calc(
    var(--hex-width) - (var(--hex-width) / (2 * var(--sqrt-3))) / 2
  );
  grid-gap: var(--hex-between) var(--hex-between);
  margin-top: 10px;
  justify-content: center;
  overflow-y: auto;
  padding-bottom: var(--hex-border);
}
.hexagon {
  align-items: center;
  background-color: var(--color-hex-default);
  cursor: pointer;
  display: flex;
  fill: white;
  color: var(--color-font-color);
  font-weight: bold;
  height: var(--hex-height);
  justify-content: center;
  margin: var(--hex-border) 0;
  position: relative;
  transition: var(--hex-transition);
  width: var(--hex-width);
  animation: showIn 1s;
}
.hexagon::after,
.hexagon::before {
  border-left: var(--hex-margin) solid transparent;
  border-right: var(--hex-margin) solid transparent;
  content: "";
  left: 0;
  position: absolute;
  transition: var(--hex-transition);
  width: 0;
}
.hexagon::after {
  border-top: var(--hex-border) solid var(--color-hex-default);
  top: 100%;
  width: 0;
}
.hexagon::before {
  border-bottom: var(--hex-border) solid var(--color-hex-default);
  bottom: 100%;
}
.hexagon:hover {
  background-color: var(--color-hex-hover);
  color: var(--color-hex-hover-color);
}
.hexagon:hover::after,
.hexagon:hover::before {
  border-top-color: var(--color-hex-hover);
  border-bottom-color: var(--color-hex-hover);
  color: var(--color-hex-hover-color);
}
.hexagon:nth-child(12n + 1),
.hexagon:nth-child(12n + 2),
.hexagon:nth-child(12n + 3),
.hexagon:nth-child(12n + 4),
.hexagon:nth-child(12n + 5),
.hexagon:nth-child(12n + 6) {
  margin-left: calc((var(--hex-width) / 4 + var(--hex-between) / 4) * -1);
}
.hexagon:nth-child(12n + 7),
.hexagon:nth-child(12n + 8),
.hexagon:nth-child(12n + 9),
.hexagon:nth-child(12n + 10),
.hexagon:nth-child(12n + 11),
.hexagon:nth-child(12n + 12) {
  margin-left: calc(var(--hex-width) / 4 + var(--hex-between) / 4);
}
</style>
